Unit QSAZC_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSAZC(A :Real; B :Real; F :Proc_F1_Q; G :Proc_F2_Q; N :Integer;
                var RINT1 :Real; var RINT2 :Real);

implementation

procedure QSAZC(A :Real; B :Real; F :Proc_F1_Q; G :Proc_F2_Q; N :Integer;
                var RINT1 :Real; var RINT2 :Real);
var
H,T,DELZ1,DELZ2,ZTL1,ZTL2,PART1,PART2 :Real;
ZT :Array [0..1] of Real;
ZK :Array [0..1] of Real;
FZ :Array [0..1] of Real;
const
ZERO :Real = 0.0;
label
_10,_20,_30;
begin
RINT1 := ZERO;
RINT2 := ZERO;
H := (B-A)/N;
T := A;
_10:
G(T,ZT);
if ( T = A ) 
 then goto _20;
DELZ1 := ZT[0]-ZTL1;
DELZ2 := ZT[1]-ZTL2;
ZK[0] := ZTL1+DELZ1/2;
ZK[1] := ZTL2+DELZ2/2;
F(ZK,FZ);
PART1 := FZ[0]*DELZ1-FZ[1]*DELZ2;
PART2 := FZ[0]*DELZ2+FZ[1]*DELZ1;
RINT1 := RINT1+PART1;
RINT2 := RINT2+PART2;
if ( T >= B-0.25*H )
 then goto _30;
_20:
ZTL1 := ZT[0];
ZTL2 := ZT[1];
T := T+H;
goto _10;
_30:
end;

end.
